Attribute VB_Name = "Gauss_Berechnen"
Option Explicit

Public strProjekt As String, strPosition As String
Public N As Integer
Public A(10, 10) As Double, B(10) As Double
Public A1(10, 10) As Double, B1(10) As Double
Public X(10) As Double
Public blnFehler As Boolean

Public Const strPgmName = "Gauss.vbp"
Public Const strVersion = "5.0"

Public Sub Hauptprogramm(ByVal blnFehler As Boolean)
'verwendete Variablennamen:
'Eingabe:    N, A(N,N), B(N)
'Gren:     C(N,N), I, J, K, EP$, NR$, S
'Ergebnisse: X(N)
Dim i As Integer, j As Integer, k As Integer
Dim C(10, 10) As Double, S As Double

blnFehler = False
'Sichern der ursprnglichen Matrix A und des Vektors B
For i = 1 To N
  For j = 1 To N
    A1(i, j) = A(i, j)
  Next j
  B1(i) = B(i)
Next i

'Berechnung: Matrix A in Dreieckform C berfhren ----------------
For j = 1 To N - 1
  If Abs(A(j, j)) < 0.00001 Then
    MsgBox ("*** Hauptdiagonalglied < 10-5!")
    blnFehler = True
    Exit Sub
  End If
  For i = j + 1 To N
    C(i, j) = -A(i, j) / A(j, j)
    For k = j + 1 To N
      A(i, k) = A(i, k) + C(i, j) * A(j, k)
    Next k
  Next i
Next j

'rechte Seite B mit C umrechnen  - - - - - - - - - - - - - - - - - - -
For j = 1 To N - 1
  For i = j + 1 To N
    B(i) = B(i) + C(i, j) * B(j)
  Next i
Next j
If Abs(A(N, N)) < 0.00001 Then
  MsgBox ("*** Hauptdiagonalglied < 10-5!")
  blnFehler = True
  Exit Sub
End If

'Lsungen X durch Rckwrtseinsetzen berechnen - - - - - - - - - - - -
For i = N To 1 Step -1
  S = B(i)
  For k = i + 1 To N
    S = S - A(i, k) * X(k)
  Next k
  X(i) = S / A(i, i)
Next i

End Sub

Public Sub Vorbelegung()
'Beispiel 3*3-Matrix
  strProjekt = "Test"
  strPosition = "1"
  N = 3
  A(1, 1) = 3: A(1, 2) = 4: A(1, 3) = 7: B(1) = 90
  A(2, 1) = 12: A(2, 2) = 10: A(2, 3) = 0: B(2) = 78
  A(3, 1) = 0: A(3, 2) = 12: A(3, 3) = 2: B(3) = 56
End Sub
